
--------------------------------------------------------------------------------------------------------------
-- Adapted from https://github.com/MIT-LCP/mimic-code/blob/master/buildmimic/postgres/postgres_add_indexes.sql
--------------------------------------------------------------------------------------------------------------


-------------
-- ADMISSIONS
-------------

DROP INDEX IF EXISTS ADMISSIONS_idx01;
CREATE INDEX ADMISSIONS_IDX01
  ON ADMISSIONS (subject_id);

DROP INDEX IF EXISTS ADMISSIONS_idx02;
CREATE INDEX ADMISSIONS_IDX02
  ON ADMISSIONS (hadm_id);
  
-------------
-- PATIENTS
-------------

DROP INDEX IF EXISTS PATIENTS_idx01;
CREATE INDEX PATIENTS_IDX01
  ON PATIENTS (subject_id);

-------------
-- TRANSFERS
-------------

DROP INDEX IF EXISTS TRANSFERS_idx01;
CREATE INDEX TRANSFERS_IDX01
  ON TRANSFERS (subject_id);
  
DROP INDEX IF EXISTS TRANSFERS_idx02;
CREATE INDEX TRANSFERS_IDX02
  ON TRANSFERS (transfer_id);
  
-------------
-- D_HCPCS
-------------

DROP INDEX IF EXISTS D_HCPCS_idx01;
CREATE INDEX D_HCPCS_IDX01
  ON D_HCPCS (code);  


-------------
-- D_ICD_DIAGNOSES
-------------

DROP INDEX IF EXISTS D_ICD_DIAGNOSES_idx01;
CREATE INDEX D_ICD_DIAGNOSES_IDX01
  ON D_ICD_DIAGNOSES (icd_code);

DROP INDEX IF EXISTS D_ICD_DIAGNOSES_idx02;
CREATE INDEX D_ICD_DIAGNOSES_IDX02
  ON D_ICD_DIAGNOSES (icd_version);

-------------
-- D_ICD_PROCEDURES
-------------

DROP INDEX IF EXISTS D_ICD_PROCEDURES_idx01;
CREATE INDEX D_ICD_PROCEDURES_IDX01
  ON D_ICD_PROCEDURES (icd_code);
  
-------------
-- D_LABITEMS
-------------

DROP INDEX IF EXISTS D_LABITEMS_idx01;
CREATE INDEX D_LABITEMS_IDX01
  ON D_LABITEMS (itemid); 


-------------
-- DIAGNOSES_ICD
-------------

DROP INDEX IF EXISTS DIAGNOSES_ICD_idx01;
CREATE INDEX DIAGNOSES_ICD_IDX01
  ON DIAGNOSES_ICD (subject_id); 


DROP INDEX IF EXISTS DIAGNOSES_ICD_idx02;
CREATE INDEX DIAGNOSES_ICD_IDX02
  ON DIAGNOSES_ICD (hadm_id); 


-------------
-- DRGCODES
-------------

DROP INDEX IF EXISTS DRGCODES_idx01;
CREATE INDEX DRGCODES_IDX01
  ON DRGCODES (subject_id); 


DROP INDEX IF EXISTS DRGCODES_idx02;
CREATE INDEX DRGCODES_IDX02
  ON DRGCODES (hadm_id); 
  
-------------
-- EMAR
-------------

DROP INDEX IF EXISTS EMAR_idx01;
CREATE INDEX EMAR_IDX01
  ON EMAR (subject_id); 


DROP INDEX IF EXISTS EMAR_idx02;
CREATE INDEX EMAR_IDX02
  ON EMAR (emar_id); 

-------------
-- EMAR_DETAIL
-------------

DROP INDEX IF EXISTS EMAR_DETAIL_idx01;
CREATE INDEX EMAR_DETAIL_IDX01
  ON EMAR_DETAIL (subject_id); 


DROP INDEX IF EXISTS EMAR_DETAIL_idx02;
CREATE INDEX EMAR_DETAIL_IDX02
  ON EMAR_DETAIL (emar_id); 


-------------
-- HCPCSEVENTS
-------------

DROP INDEX IF EXISTS HCPCSEVENTS_idx01;
CREATE INDEX HCPCSEVENTS_IDX01
  ON HCPCSEVENTS (subject_id); 


DROP INDEX IF EXISTS HCPCSEVENTS_idx02;
CREATE INDEX HCPCSEVENTS_IDX02
  ON HCPCSEVENTS (hadm_id); 

-------------
-- LABEVENTS
-------------

DROP INDEX IF EXISTS labevents_1_idx01;
CREATE INDEX labevents_1_idx01 ON labevents_1 (itemid);
DROP INDEX IF EXISTS labevents_2_idx01;
CREATE INDEX labevents_2_idx01 ON labevents_2 (itemid);
DROP INDEX IF EXISTS labevents_3_idx01;
CREATE INDEX labevents_3_idx01 ON labevents_3 (itemid);
DROP INDEX IF EXISTS labevents_4_idx01;
CREATE INDEX labevents_4_idx01 ON labevents_4 (itemid);
DROP INDEX IF EXISTS labevents_5_idx01;
CREATE INDEX labevents_5_idx01 ON labevents_5 (itemid);
DROP INDEX IF EXISTS labevents_6_idx01;
CREATE INDEX labevents_6_idx01 ON labevents_6 (itemid);
DROP INDEX IF EXISTS labevents_7_idx01;
CREATE INDEX labevents_7_idx01 ON labevents_7 (itemid);
DROP INDEX IF EXISTS labevents_8_idx01;
CREATE INDEX labevents_8_idx01 ON labevents_8 (itemid);
DROP INDEX IF EXISTS labevents_9_idx01;
CREATE INDEX labevents_9_idx01 ON labevents_9 (itemid);
DROP INDEX IF EXISTS labevents_10_idx01;
CREATE INDEX labevents_10_idx01 ON labevents_10 (itemid);


-------------
-- MICROBIOLOGYEVENTS
-------------

DROP INDEX IF EXISTS MICROBIOLOGYEVENTS_idx01;
CREATE INDEX MICROBIOLOGYEVENTS_IDX01
  ON MICROBIOLOGYEVENTS (subject_id); 


DROP INDEX IF EXISTS MICROBIOLOGYEVENTS_idx02;
CREATE INDEX MICROBIOLOGYEVENTS_IDX02
  ON MICROBIOLOGYEVENTS (micro_specimen_id); 
  
  
-------------
-- PHARMACY
-------------

DROP INDEX IF EXISTS PHARMACY_idx01;
CREATE INDEX PHARMACY_IDX01
  ON PHARMACY (subject_id); 


DROP INDEX IF EXISTS PHARMACY_idx02;
CREATE INDEX PHARMACY_IDX02
  ON PHARMACY (hadm_id); 

DROP INDEX IF EXISTS PHARMACY_idx03;
CREATE INDEX PHARMACY_IDX03
  ON PHARMACY (pharmacy_id); 

-------------
-- POE
-------------

DROP INDEX IF EXISTS POE_idx01;
CREATE INDEX POE_IDX01
  ON POE (subject_id); 

DROP INDEX IF EXISTS POE_idx02;
CREATE INDEX POE_IDX02
  ON POE (hadm_id); 

DROP INDEX IF EXISTS POE_idx03;
CREATE INDEX POE_IDX03
  ON POE (poe_id); 

-------------
-- POE_DETAIL
-------------

DROP INDEX IF EXISTS POE_DETAIL_idx01;
CREATE INDEX POE_DETAIL_IDX01
  ON POE_DETAIL (subject_id); 

DROP INDEX IF EXISTS POE_DETAIL_idx02;
CREATE INDEX POE_DETAIL_IDX02
  ON POE_DETAIL (poe_id); 


-------------
-- PRESCRIPTIONS
-------------

DROP INDEX IF EXISTS PRESCRIPTIONS_idx01;
CREATE INDEX PRESCRIPTIONS_IDX01
  ON PRESCRIPTIONS (subject_id); 


DROP INDEX IF EXISTS PRESCRIPTIONS_idx02;
CREATE INDEX PRESCRIPTIONS_IDX02
  ON PRESCRIPTIONS (hadm_id); 

DROP INDEX IF EXISTS PRESCRIPTIONS_idx03;
CREATE INDEX PRESCRIPTIONS_IDX03
  ON PRESCRIPTIONS (pharmacy_id); 
  
-------------
-- PROCEDURES_ICD
-------------

DROP INDEX IF EXISTS PROCEDURES_ICD_idx01;
CREATE INDEX PROCEDURES_ICD_IDX01
  ON PROCEDURES_ICD (subject_id); 


DROP INDEX IF EXISTS PROCEDURES_ICD_idx02;
CREATE INDEX PROCEDURES_ICD_IDX02
  ON PROCEDURES_ICD (hadm_id); 

DROP INDEX IF EXISTS PROCEDURES_ICD_idx03;
CREATE INDEX PROCEDURES_ICD_IDX03
  ON PROCEDURES_ICD (icd_code);
  
 -------------
-- SERVICES
-------------

DROP INDEX IF EXISTS SERVICES_idx01;
CREATE INDEX SERVICES_IDX01
  ON SERVICES (subject_id); 


DROP INDEX IF EXISTS SERVICES_idx02;
CREATE INDEX SERVICES_IDX02
  ON SERVICES (hadm_id); 


-------------
-- D_ITEMS
-------------

DROP INDEX IF EXISTS D_ITEMS_idx01;
CREATE INDEX D_ITEMS_IDX01
  ON D_ITEMS (itemid); 


-------------
-- CHARTEVENTS
-------------

DROP INDEX IF EXISTS CHARTEVENTS_1_idx01;
CREATE INDEX CHARTEVENTS_1_idx01 ON CHARTEVENTS_1 (itemid);
DROP INDEX IF EXISTS CHARTEVENTS_2_idx01;
CREATE INDEX CHARTEVENTS_2_idx01 ON CHARTEVENTS_2 (itemid);
DROP INDEX IF EXISTS CHARTEVENTS_3_idx01;
CREATE INDEX CHARTEVENTS_3_idx01 ON CHARTEVENTS_3 (itemid);
DROP INDEX IF EXISTS CHARTEVENTS_4_idx01;
CREATE INDEX CHARTEVENTS_4_idx01 ON CHARTEVENTS_4 (itemid);
DROP INDEX IF EXISTS CHARTEVENTS_5_idx01;
CREATE INDEX CHARTEVENTS_5_idx01 ON CHARTEVENTS_5 (itemid);
DROP INDEX IF EXISTS CHARTEVENTS_6_idx01;
CREATE INDEX CHARTEVENTS_6_idx01 ON CHARTEVENTS_6 (itemid);
DROP INDEX IF EXISTS CHARTEVENTS_7_idx01;
CREATE INDEX CHARTEVENTS_7_idx01 ON CHARTEVENTS_7 (itemid);
DROP INDEX IF EXISTS CHARTEVENTS_8_idx01;
CREATE INDEX CHARTEVENTS_8_idx01 ON CHARTEVENTS_8 (itemid);
DROP INDEX IF EXISTS CHARTEVENTS_9_idx01;
CREATE INDEX CHARTEVENTS_9_idx01 ON CHARTEVENTS_9 (itemid);
DROP INDEX IF EXISTS CHARTEVENTS_10_idx01;
CREATE INDEX CHARTEVENTS_10_idx01 ON CHARTEVENTS_10 (itemid);


-------------
-- DATETIMEEVENTS
-------------

DROP INDEX IF EXISTS DATETIMEEVENTS_idx01;
CREATE INDEX DATETIMEEVENTS_IDX01
  ON DATETIMEEVENTS (subject_id); 


DROP INDEX IF EXISTS DATETIMEEVENTS_idx02;
CREATE INDEX DATETIMEEVENTS_IDX02
  ON DATETIMEEVENTS (hadm_id); 


-------------
-- ICUSTAYS
-------------

DROP INDEX IF EXISTS ICUSTAYS_idx01;
CREATE INDEX ICUSTAYS_IDX01
  ON ICUSTAYS (subject_id); 


DROP INDEX IF EXISTS ICUSTAYS_idx02;
CREATE INDEX ICUSTAYS_IDX02
  ON ICUSTAYS (hadm_id); 

DROP INDEX IF EXISTS ICUSTAYS_idx03;
CREATE INDEX ICUSTAYS_IDX03
  ON ICUSTAYS (stay_id);


-------------
-- INPUTEVENTS
-------------

DROP INDEX IF EXISTS INPUTEVENTS_idx01;
CREATE INDEX INPUTEVENTS_IDX01
  ON INPUTEVENTS (subject_id); 


DROP INDEX IF EXISTS INPUTEVENTS_idx02;
CREATE INDEX INPUTEVENTS_IDX02
  ON INPUTEVENTS (hadm_id); 

DROP INDEX IF EXISTS INPUTEVENTS_idx03;
CREATE INDEX INPUTEVENTS_IDX03
  ON INPUTEVENTS (stay_id);


-------------
-- OUTPUTEVENTS
-------------

DROP INDEX IF EXISTS OUTPUTEVENTS_idx01;
CREATE INDEX OUTPUTEVENTS_IDX01
  ON OUTPUTEVENTS (subject_id); 


DROP INDEX IF EXISTS OUTPUTEVENTS_idx02;
CREATE INDEX OUTPUTEVENTS_IDX02
  ON OUTPUTEVENTS (hadm_id); 

DROP INDEX IF EXISTS OUTPUTEVENTS_idx03;
CREATE INDEX OUTPUTEVENTS_IDX03
  ON OUTPUTEVENTS (stay_id);
  
  
-------------
-- PROCEDUREEVENTS
-------------

DROP INDEX IF EXISTS PROCEDUREEVENTS_idx01;
CREATE INDEX PROCEDUREEVENTS_IDX01
  ON PROCEDUREEVENTS (subject_id); 


DROP INDEX IF EXISTS PROCEDUREEVENTS_idx02;
CREATE INDEX PROCEDUREEVENTS_IDX02
  ON PROCEDUREEVENTS (hadm_id); 

DROP INDEX IF EXISTS PROCEDUREEVENTS_idx03;
CREATE INDEX PROCEDUREEVENTS_IDX03
  ON PROCEDUREEVENTS (stay_id);
  
  
  
